;  
;      *
;  LCD: WH0802A

    list        p=16f688
    #include <p16f688.inc>

    __CONFIG _CP_OFF & _WDT_OFF & _BOREN_OFF & _PWRTE_ON & _FOSC_INTOSCIO & _MCLRE_ON &_IESO_OFF &_FCMEN_OFF

;--------- -----------------------

    #DEFINE RS PORTC,5
    #DEFINE E PORTC,4
    #DEFINE LOAD PORTA,5

    constant DelU=0x66          ;  Div16by8     U  

    constant countUL=0x3        ;   U     ( ,   )
    constant countUH=0x3        ;   U     ( ,   )
    constant Uth72H=0x02        ;   7.2
    constant Uth72L=0xE1        ;   7.2
    constant Uth64H=0x02        ;   6
    constant Uth64L=0x66        ;   6

    constant numTMRon=0x8       ;   TMR1 (   )

    constant inTMR1H=0x0B       ;    TMR1       500
    constant inTMR1L=0xD9

    constant DelNL=0x5A         ;    
                                ;   DelNL=3600/T*I*10
                                ;T   ,    
                                ;I -     

;---------  ----------------
 Cblock 20h

    ThrCountL              ;    U   ( ,   )
    ThrCountH              ;    U   ( ,   )

    tmpD1                  ;.    2
    tmpD2                  ;.    40
    tmpD3                  ;.    2
    tmpC                   ;.     LCD
    tmpW                   ;     LCD
    RESULTHI               ;   A/D 
    RESULTLO               ;   A/D 

    LEDrezH                ;     ,  
    LEDrezL                ;     ,  
    CountB                 ;   Bin2_10
    Mem                    ;   Bin2_10
    LEDbin                 ;    Bin2_10

    dvdh                   ;       Div16by8
    dvdl                   ;  8      dvdl
    resh                   ;     Div16by8
    resl                   ;     Div16by8
    dvzh                   ; 8 
    dvzl                   ;    Div16by8
    cnt0                   ;    Div16by8
    temph                  ;    Div16by8
    templ                  ;    Div16by8

    resmultL               ;     Multiply 8 x 8 bits
    resmultH               ;     Multiply 8 x 8 bits
    mulplr                 ;  Multiply 8 x 8 bits

    Uint                   ;    . U  
    Ufrac                  ;    . U  

    nTMR1                  ;    TMR1
    nLOADL                 ;    
    nLOADH                 ;    

    CmAH                   ;         mA
    CmAL


 endc


 ORG 05
RES_VECT  CODE    0x0000            ; processor reset vector
    GOTO    INIT                   ; go to beginning of program

;***************************************************************
;               
;***************************************************************
;---------------- ----------------------

INIT
    banksel OSCCON                  ;  1
    movlw b'01100001'               ;   (4)
    movwf OSCCON
    NOP
    banksel PORTA
    clrf PORTA
    clrf PORTC
    banksel TRISA
    movlw b'00010000'               ;   
    movwf TRISA
    bsf LOAD                        ; 
    movlw b'00000000'               ;   
    movwf TRISC
    movlw b'00001000'               ;RA4   
    movwf ANSEL
    movlw	B'00000000'             ; 
	movwf	INTCON
    movlw b'11000000'
    movwf OPTION_REG                ;  
    banksel CMCON0
    movlw b'00000111'               ; 
    movwf CMCON0
    banksel PORTA
    movlw b'00110000'               ;  TMR1
    movwf T1CON



;---------------- LCD--------------------

Init_LCD
    CALL delay40000                 ; 40 
    movlw 0x2
    movwf PORTC                     ;funtion set
    call strob
    call delay40                    ; 40 
    movlw 0x2C                      ;funtion set
    call LEDcom
    call delay40                    ; 40 
    movlw 0x2C                      ;funtion set
    call LEDcom
    call delay40
    movlw 0xC                       ;Display ON/OFF control
    call LEDcom
    call delay40                    ; 40 
    movlw 0x1                       ;Display Clear
    call LEDcom
    call delay2000
    movlw 6                         ;Entry Mode Set
    call LEDcom
    CALL delay2000

;----------- A/D ------

    banksel ADCON1
    MOVLW B'01010000'               ;  F=Fosc/16
    MOVWF ADCON1
    banksel ADCON0
    MOVLW B'10001100'               ;  ,   ,
    MOVWF ADCON0                    ;    (RA4)
    bsf ADCON0,0                    ; 
    call delay40000

;*****************************************************
;            
;*****************************************************

start

;--------- ,   --------

    clrf nLOADH             ;   
    clrf nLOADL
    movlw countUL           ;    U
    movwf ThrCountL
    movlw countUH
    movwf ThrCountH
    bcf LOAD                ; 
    bsf PORTA,2             ; 
    call delay1s            ; 1

beginThr
    call IzmU               ;   
                            ;  16    
    movf RESULTHI,W         ; ,      7,2
    addlw -Uth72H           ;  
    btfss STATUS,C          ;   (=0)    
    goto terminate          ;   
    skpz                    ; .  ,    
    goto then               ;   (    )
    movf RESULTLO,W
    addlw -Uth72L           ;  
    skpc                    ;   (=0)    
    goto terminate          ;   
    goto then
then                        ;U  
    decfsz ThrCountH
    goto beginThr           ;     U
    bsf LOAD                ; 
    bcf PORTA,2             ; 
    goto then1              ;   
terminate                   ;U  
    decfsz ThrCountL
    goto beginThr           ;     U
    goto terminate1         ;   

;--------    " "------------
;--------(        7,2 )--------------

terminate1
    bsf LOAD                ; 
    bcf PORTA,2             ; 
    movlw 0x80              ;    
    call LEDcom
    movlw 0xA4              ;
    call LEDwrite
    movlw 0x41              ;
    call LEDwrite
    movlw 0x50              ;
    call LEDwrite
    movlw 0xB1              ;
    call LEDwrite
    movlw 0xE0              ;
    call LEDwrite
    movlw 0xA5              ;
    call LEDwrite
    movlw 0x54              ;
    call LEDwrite
    movlw 0x45              ;
    call LEDwrite
    movlw 0xC0              ;    
    call LEDcom
    movlw 0xA0              ;
    call LEDwrite
    movlw 0x41              ;
    call LEDwrite
    movlw 0x54              ;
    call LEDwrite
    movlw 0x41              ;
    call LEDwrite
    movlw 0x50              ;
    call LEDwrite
    movlw 0x45              ;
    call LEDwrite
    movlw 0xB0              ;
    call LEDwrite

    bsf PORTA,2             ; 
    call delay2s
    bcf PORTA,2             ; 
    call delay2s
    goto    $-4

;-----    ,   ----------

then1
    movlw numTMRon          ;    TMR1   nTMR1
    movwf nTMR1
    bcf LOAD                ; 
then2
    movlw inTMR1H           ;       TMR1
    movwf TMR1H
    movlw inTMR1L           ;       TMR1
    movwf TMR1L
    bsf T1CON,0             ; 
    call delay40000         ; 40 
    movlw countUL           ;    U
    movwf ThrCountL
    movlw countUH
    movwf ThrCountH
beginThr64
    call IzmU               ;   
                            ;  16    
    movf RESULTHI,W         ; ,      6,4
    addlw -Uth64H           ;  
    btfss STATUS,C          ;   (=0)    
    goto enddisch           ;   
    skpz                    ; .  ,    
    goto disch              ;   (    )
    movf RESULTLO,W
    addlw -Uth64L           ;  
    skpc                    ;   (=0)    
    goto enddisch           ;   
    goto disch
disch                       ;U  
    decfsz ThrCountH
    goto beginThr64         ;     U
    goto disch1             ;   
enddisch                    ;U  
    decfsz ThrCountL
    goto beginThr64         ;     U
    goto enddisch1          ;   

;----  -----------------
enddisch1
    bsf LOAD                ; 
    bcf T1CON,0             ; 
;---  -------------------------
    movf nLOADH,W
    movwf dvdh              ;       Div16by8
    movf nLOADL,W
    movwf dvdl
    movlw DelNL             ;   Div16by8
    movwf dvzh
    call Div16by8           ;  .   .  
    movfw resl
    movwf CmAH              ;    mA*H  
    call mpy_F              ;  100   
    movfw resmultH          ;  100        Div16by8
    movwf dvdh
    movfw resmultL
    movwf dvdl
    movlw DelNL             ;   Div16by8
    movwf dvzh
    call Div16by8           ;    mA*H  
    movfw resl              ;      CmAL
    movwf CmAL
    movlw 0x1               ;Display Clear
    call LEDcom
    call delay2000
    movlw 0x80              ;    
    call LEDcom
    movlw 0x20              ;
    call LEDwrite
    movlw 0x20              ;
    call LEDwrite
    movfw CmAH              ;      LEDbin
    movwf LEDbin
    call Bin2_10            ;      -
    movlw 30                ;         .
    addwf LEDrezL
    movlw 30
    addwf LEDrezH
    movfw LEDrezH           ;       *  
    call LEDwrite
    movfw LEDrezL
    call LEDwrite
    movfw CmAL
    movwf LEDbin            ;      LEDbin
    call Bin2_10            ;      -
    movlw 30                ;         .
    addwf LEDrezL
    movlw 30
    addwf LEDrezH
    movfw LEDrezH           ;       *  
    call LEDwrite
    movfw LEDrezL
    call LEDwrite
    movlw 0xC0              ;    
    call LEDcom
    movlw 0x20              ;
    call LEDwrite
    movlw 0x20              ;
    call LEDwrite
    movlw 0xBC              ;
    call LEDwrite
    movlw 0x41              ;A
    call LEDwrite
    movlw 0x2A              ;*
    call LEDwrite
    movlw 0xAB              ;
    call LEDwrite
    bsf PORTA,2             ; 
    call delay1s
    bcf PORTA,2             ; 
    call delay1s
    goto    $-4

;----  
disch1
    movf RESULTHI,W
    movwf dvdh              ;      Div16by8
    movf RESULTLO,W
    movwf dvdl
    movlw DelU              ;   Div16by8
    movwf dvzh
    call Div16by8           ;     ,   U   ( )
    movfw resl
    movwf Uint              ;   (  U  )   Uint
    call mpy_F              ;  100   
    movfw resmultH          ;  100        Div16by8
    movwf dvdh
    movfw resmultL
    movwf dvdl
    movlw DelU              ;   Div16by8
    movwf dvzh
    call Div16by8           ;   U    
    movfw resl
    movwf Ufrac             ;   (  U  )   Ufrac
    movfw Uint
    movwf LEDbin            ;    U   LEDbin
    call Bin2_10            ;      -
    movlw 30                ;      
    addwf LEDrezL           ;  
    movlw 0x80              ;    
    call LEDcom
    movlw 0x50              ;
    call LEDwrite
    movlw 0x41              ;A
    call LEDwrite
    movlw 0xA4              ;
    call LEDwrite
    movlw 0x50              ;
    call LEDwrite
    movlw 0xB1              ;
    call LEDwrite
    movlw 0xE0              ;
    call LEDwrite
    movlw 0xC0              ;    
    call LEDcom
    movlw 0x55              ;U
    call LEDwrite
    movlw 0x3D              ;=
    call LEDwrite
    movfw LEDrezL           ;        
    call LEDwrite
    movlw 0x2C              ; 
    call LEDwrite
    movfw Ufrac
    movwf LEDbin            ;    U   LEDbin
    call Bin2_10            ;      -
    movlw 30                ;      
    addwf LEDrezL           ;  
    addwf LEDrezH
    movfw LEDrezH           ;        
    call LEDwrite
    movfw LEDrezL
    call LEDwrite
    movlw 0x20              ; 
    call LEDwrite
    movlw 0x42              ;  B
    call LEDwrite
    BTFSS PIR1,0            ;   TMR1?
    GOTO $-1                ;,  
    bcf T1CON,0             ; 
    bcf PIR1,0              ;  
    decfsz nTMR1            ;       
    goto then2              ;     
    goto then3              ;    
then3
    CLRC
    movfw nLOADL
    addlw 0x01              ;  nLOAD (  )
    movwf nLOADL
    SKPNC
    incf nLOADH
    bsf LOAD                ; 
    call delay2s
    goto then1

;*********************************************************
;                  A/D
;*********************************************************
IzmU
    BANKSEL ADCON0
    BSF ADCON0,GO                   ;Start conversion
    BTFSC ADCON0,GO                 ;Is conversion done?
    GOTO $-1                        ;No, test again
    MOVF ADRESH,W                   ;Read upper 2 bits
    MOVWF RESULTHI                  ;store in GPR space
    BANKSEL ADRESL
    MOVF ADRESL,W                   ;Read lower 8 bits
    BANKSEL ADRESH
    MOVWF RESULTLO                  ;Store in GPR space
    return
;****************************************************
;         
;****************************************************
;----------------------Div16by8-------------------------------------------------------------
;  16    8 ,      
;dvdh  dvdl     
;dvzh - 
; -   resh,resl
;   dvdl
;-------------------------------------------------------------------------------------------
Div16by8
 clrf resh      ;   
 clrf resl
 clrf dvzl      ;  .  
 clrc
 movlw .9       ; .  
 movwf cnt0     ;   

shiftL        ;      
 btfsc dvzh,7
 goto subs
 rlf dvzh,f
 incf cnt0,f
 goto shiftL

subs
 movfw dvzl
 subwf dvdl,w   ;  .    .  
 movwf templ    ; 
 movfw dvzh
 skpc           ;   
 incf dvzh,w    ;  
 subwf dvdh,w   ;  .    .  
 movwf temph    ; 
 skpc           ;   
 goto div_01    ;      
 goto div_02    ;       

div_01          ;       
 rlf resl,f     ;      (=0)  . 
 rlf resh,f
 clrc
 goto shiftDVZ_R

div_02          ;       
 rlf resl,f     ;      (=1)  . 
 rlf resh,f
 clrc           ;   
 movfw temph
 movwf dvdh     ;    
 movfw templ
 movwf dvdl

shiftDVZ_R
 rrf dvzh,f     ;   
 rrf dvzl,f
 clrc
 decfsz cnt0,f  ;  
 goto subs
 return

;----------Multiply 8 x 8 bits---------------------------
;      .100
;   dvdl (    Div16by8)
;    resmultH resmultL
;--------------------------------------------------------

;****   Define a macro for adding & right shifting  **
mult    MACRO   bit             ; Begin macro
        btfsc   mulplr,bit
        addwf   resmultH,1
        rrf     resmultH,1
        rrf     resmultL,1
        ENDM                    ; End of macro
;
; ***************************** Begin Multiplier Routine
mpy_F   movlw .100
        movwf mulplr        ;    
        clrf    resmultH
        clrf    resmultL
        movf    dvdl,W      ; move the multiplicand to W reg.
        bcf     STATUS,C    ; Clear the carry bit in the status Reg.
        mult    0
        mult    1
        mult    2
        mult    3
        mult    4
        mult    5
        mult    6
        mult    7
        retlw   0

;-------------Bin2_10------------------------------------
;     ( 99)
;  - .
;--------------------------------------------------------
Bin2_10
    bcf STATUS,C            ;   -.
    movlw .8                ;    Count   ,
    movwf CountB            ;      LED
    clrf LEDrezH           ;  
    clrf LEDrezL           ;  
;--------  -------------------------
loop16
    rlf LEDbin             ;   
    rlf LEDrezL            ;   
    rlf LEDrezH            ;        STATUS

    decfsz CountB           ;    Count      
    goto adjDEC             ;   =0,     adjDEC
                            ;    =0,    .
;-----    LEDrezL
;    LEDrezL LEDrezH------------------
    swapf LEDrezL,W         ;    LEDfrezL
    andlw 0Fh               ;    LEDfrezH.
    movwf LEDrezH
    movfw LEDrezL           ;    LEDfrezL
    andlw 0Fh               ;    LEDfrezL.
    movwf LEDrezL

    return
;-------------------------------------------------------------------
adjDEC
    movlw LEDrezL           ;    FSR,   W,   LEDfrezL
    movwf FSR               ;      adjBCD
    call adjBCD
    movlw LEDrezH          ;      LEDrezH
    movwf FSR
    call adjBCD
    goto loop16
;-------------------------------------------------------------------
adjBCD
    movlw 3                 ;    LED (LED0...3)   03h,
    addwf 0,W               ; c   ,   W,
    movwf Mem               ;   Mem.
    btfsc Mem,3             ;   3-   Mem.
    movwf 0                 ;    3 =1,    Mem    LED
    movlw 30                ;   3 =0,    LED 
    addwf 0,W               ;   30h,     ,
    movwf      Mem          ;   W,   Mem.
    btfsc      Mem,7        ;   7-   Mem.
    movwf      0            ;   7 =1,    Mem    LED.
    retlw      0            ;   7 =0,  W         adjDEC.

;****************************************************
;           LCD
;****************************************************
;----------    LCD------------------
LEDcom
    movwf   tmpC		;    tmpC
	swapf   tmpC,W		;  ,   W
    andlw 0xF           ;         ()
    movwf   PORTC		;
    bcf     RS          ;  
    call    strob		; 
    movf tmpC,0
    andlw 0xF
    movwf   PORTC
    bcf     RS
    call    strob
    retlw 0
;-------------    LCD----------------
LEDwrite
    movwf   tmpW		;
	swapf   tmpW,W		;
    andlw 0xF
 	movwf   PORTC       ;  
    bsf     RS          ;  
    call    strob       ; 
    movf tmpW,0
    andlw 0xF
    movwf PORTC         ;  
    bsf     RS          ;  
    call    strob       ; 
    retlw 0

;-------  100-------------------
strob
    movlw .25
    bsf E
    addlw   -1
	btfss   STATUS,2
	goto    $-2
    bcf E
    return

;*****************************************************
;           
;*****************************************************
;---------- 40------------------------------
delay40
	movlw   .10		;40 .
	addlw   -1
	btfss   STATUS,2
	goto    $-2
	return
;---------- 2-------------------------------
delay2000
    movlw   .50
	movwf tmpD1
    call delay40  ;
    decfsz tmpD1
	goto    $-2
    return
;----------- 40------------------------------
delay40000
    movlw   .20
	movwf tmpD2
    call delay2000  ;
    decfsz tmpD2
	goto    $-2
    return

    ;----------- 2------------------------------
delay2s
    movlw d'50'
	movwf tmpD3
    call delay40000  ;
    decfsz tmpD3
	goto    $-2
    return

;----------- 1------------------------------
delay1s
    movlw d'25'
	movwf tmpD3
    call delay40000  ;
    decfsz tmpD3
	goto    $-2
    return

    END


